/*
 * LISTING 2: support.cc
 */

#include <stdlib.h>
#include <iostream.h>
#include <fstream.h>
#include <CORBA.h>
#include "support.h"

/*
 * Abfrage eines Variablentyps von der Console
 */
CORBA::TypeCode_ptr queryType()
{
    char                buffer[100];
    int                 loopDone;
    CORBA::TypeCode_var typeCode;

    do {
        loopDone = TRUE;

        cout << "Typ auswaehlen (long, ulong, bool, void) : ";
        cin  >> buffer;

        if(!strcmp(buffer, "long")) {
            typeCode = CORBA::_tc_long;
        } else if(!strcmp(buffer, "ulong")) {
            typeCode = CORBA::_tc_ulong;
        } else if(!strcmp(buffer, "bool")) {
            typeCode = CORBA::_tc_boolean;
        } else if(!strcmp(buffer, "void")) {
            typeCode = CORBA::_tc_void;
        } else {
            cout << "Ungueltige Eingabe." << endl;
            loopDone = FALSE;
        }
    } while(!loopDone);

    return typeCode;
}

/*
 * Abfrage eines Wertes von der Console
 */
void queryValue(CORBA::Any* value)
{
    char                buffer[100];
    CORBA::TypeCode_var typeCode;

    typeCode = value->type();

    cout << "Wert eingeben: ";
    cin >> buffer;

    if(typeCode == CORBA::_tc_long) {
        *value <<= ((CORBA::Long) strtol(buffer, (char**)NULL, 10));
    } else if(typeCode == CORBA::_tc_ulong) {
        *value <<= ((CORBA::ULong) strtoul(buffer, (char**)NULL, 10));
    } else if(typeCode == CORBA::_tc_boolean) {
        if(!strcmp(buffer, "false")) {
            *value <<= CORBA::Any::from_boolean(FALSE);
        } else if(!strcmp(buffer, "true")) {
            *value <<= CORBA::Any::from_boolean(TRUE);
        }
    }
}

/*
 * Abfrage eines Variablentyps und deren Wertes von der Console
 */
void queryTypeValue(CORBA::Any* value)
{
    value->type(queryType());
    queryValue(value);
}

/*
 * Ausgabe eines Any (Variable mit unterschiedlichen Typen) auf Console
 */
void printAny(CORBA::Any* value)
{
    CORBA::TypeCode_var typeCode;

    typeCode = value->type();

    if(typeCode == CORBA::_tc_long) {
        CORBA::Long longVal;
        *value >>= longVal;
        cout << longVal;
    } else if(typeCode == CORBA::_tc_ulong) {
        CORBA::ULong ulongVal;
        *value >>= ulongVal;
        cout << ulongVal;
    } else if(typeCode == CORBA::_tc_boolean) {
        CORBA::Boolean boolVal;
        *value >>= CORBA::Any::to_boolean(boolVal);
        cout << boolVal;
    }
}

/*
 * Ausgabe eines Parameters mit Wert
 */
void printParameter(CORBA::NamedValue* value)
{
    cout << "Name: " << value->name() << " Wert: ";
    printAny(value->value());
    cout << endl;
}
